   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import java.net.*;
   import project.util.*;
   import java.io.*;
   import java.util.*;
   import project.gui.*;
   import javax.swing.tree.*;

   public class Client { /*begin class Client*/
   
      private ServerSocket serverSocket = null;
   
   	/** Just for tests.*/
      private int p; 
   	/** We have to find out whether we sent port number or not. If so we can start server, if not no need 
   	    to start server.*/ 
      private boolean portNumberSent = false;
      /** Will be used by other classes because of setEnabled (true or false). If there is no connection, there
          cannot be other commands executed.*/
      private boolean connectionEstablished = false;
      private Socket clientSocket = null;
      /** An instance of the class ClientThread, will be started from class Client. */
      private ClientThread cThread;
   	/** To read what comes from server we need an input stream. DataInputStream offers the functionality
   	    that we need. */
      private DataInputStream dataInputStream = null;
      /** To save entries for short, long database names as well as IDs. */
   
   	/** Total length of data being sent from server will be read here. It will be computed from the first 
   	    four bytes of the input stream. The following forumula is being used for computation:
   	    totalLength = header[0] + 256*(header[1] + 256*(header[2] + 256 * header[3]));
   		 where header[x] indicates xth element of the byte array received.
   	  */ 
      private int totalLength = -1;
   	/////////////////////////////////////////////////////////////////////////////////////////////////
   
   
      public void closeConnection() throws IOException {
         try {
            System.out.println("IN server");
         
            clientSocket.close();
            serverSocket.close();
            dataInputStream.close(); // close input stream, since we do not need it any more
         
         }
            catch (IOException e) {
               System.out.println("catch in server");}      
      
      }
   
      /** This method serves to find out whether there is a connection established or not. Returns true is there is a 
     * connection, or false if there is no connection.
     */
   
      public boolean isConnectionEstablished() { // begin isConnectionEstablished
         if (connectionEstablished) {
            return true;
         }
         else {
            return false;
         }
      } // end isConnectionEstablished
   
   
      /** This method serves to get information about test programs that are saved in a TestProgramTree 
          instance. This method is only used by load command. Returns TestProgramTree. 
     }
   
   
      /** Does nothing, needed just for probe by other classes */
      public Client() {
      
      }
   
   /** Creates an instance of class Client. Arguments that are given are to be used for creating a connection.
     *@param address is the name of the computer on which server runs. It defaults to szbg (VAX server).
     *@param port_number is the port number that will be used by client to make a connection with primary server.
     */
      public Client(String address, String port_number) throws IOException{ // begin constructor Client
         serverSocket = null;
         int i = 0;
         Socket cSocket = null;
         PrintWriter out = null;
      
         int message = 0;	
         boolean listening = true;
      
      
      } /* end constructor Client */
   
   /** This class provides for geting data from the secondary server(VAX). It is implemented as a thread, since InputStram.read() is 
   * a blocking call. An instance of this class is useful only then when there are some data that are being recieved from server,
   * but it is difficult to say when data are going to be received. Due to this reason, this class is implemented as a thread, and
   * runs (parallel) with the main program.
   *@version 1.0
   *@author Huskic Zenon
   */
   
      private class ClientThread extends Thread  {
      
         String inputLine = null;
         private Socket socket = null;
      
      
      /** Invoking this constructor creates an instance of the class ClientThread, with the socket given as an argument.
      *@version 1.0
      *@author Huskic Zenon
      */
         private ClientThread(Socket socket) {
            this.socket = socket;
         
         } 
      /** This method servers to read all bytes from an InputStream. These bytes are sent from secondary
      	 server in response to view command sent by the user. Sending view command to the secondary
      	 server invokes a function on server which calls pascal interface, and interface creates a 
      	 file and calls other pascal functions and procedures in tpdu_ada.pas. The file will be open by
      	 the server and sent to the client. Bytes that come will be read through this method. Take care
      	 that you always use readFully(byte[] b) method in order to read so many bytes as wanted. Usage
      	 of read(byte[] b) does not always result as wanted.
        */
      
      /** Serves to process the bytes that come from the server. It takes twho arguments DataInputStream and the Length, that is 
      * being delivered from the secondary server in the first four bytes of the data.
      */
            	/** Serves to get bytes from server. These bytes are actually the test program to be edited.
      	  * These bytes will be used to feed a test program editor instance that shows the test
      	  * program to the user, who can edit test program now, make syntax check, save it, ... 	  
      	  */      
      
      	/** The most important part of the ClientThread class. Here the number of bytes will be determined,
      	    header will be stripped off, and depending on the request Id (and hence on command), matching 
      	    method will be executed. It will be determined with the help of switch statement.
      	  */
      
         public void run() {
         
            String s;
            InputStream inputStream;
            InputStreamReader inputStreamReader;
            System.out.println("run in thread started1");
         
            try {
            
            
               int requestIdRecieved = -1;
               int logOrTable = -1;
               int retval;          
               int header[] = {0, 0, 0, 0, 0, 0}; // six bytes for reply header
               System.out.println("run in thread started2");
            
               inputStream = socket.getInputStream();
               dataInputStream = new DataInputStream(inputStream);
            
               while(true) { 
               
               	// read in the values for header      
                  header[0] = dataInputStream.readUnsignedByte();System.out.println("From Secondary Server as 0: " + header[0]);
                  header[1] = dataInputStream.readUnsignedByte();System.out.println("From Secondary Server as 1: " + header[1]);
                  header[2] = dataInputStream.readUnsignedByte();System.out.println("From Secondary Server as 2: " + header[2]);
                  header[3] = dataInputStream.readUnsignedByte();System.out.println("From Secondary Server as 3: " + header[3]);
                  totalLength = header[0] + 256*(header[1] + 256*(header[2] + 256 * header[3]));
                  System.out.println("Total length is: " + totalLength);
                  totalLength = totalLength - 4;
                  if (totalLength > 0) {
                     requestIdRecieved = dataInputStream.read(); 
                     totalLength--; 
                     System.out.println("requestID = " + requestIdRecieved);
                     logOrTable = dataInputStream.read();
                     totalLength--;
                     System.out.println("ok = " + logOrTable);
                  }
               
                  System.out.println("Total length pure is: " + totalLength); 
                  if (totalLength > 0) {
                  // first have to check whether we have a valid requestID
                  // a valid requestID is only then when it is less then or equal to the greatest requestID
                  // PROBLEM: what if requestID is smaller then this value?
                  // I think that TCP does all the work already, the only problem is that data should be 
                  // sent correctly from server and correctly recieved by reciever!!!!!!!!!!!11
                  // if (requestIdRecieved <= ((CommandRequestEntry)commandRequestVector.lastElement()).getRequestId()) {
                  
                     switch(((CommandRequestEntry)commandRequestVector.get(requestIdRecieved)).getCommand()) {
                        case 1: processLogFile(dataInputStream, totalLength);
                           break;
                        case 2: processSiteInfo(dataInputStream, totalLength);
                           break;
                        case 3: processFileToEdit(dataInputStream, totalLength);
                           break;
                        case 4: processSyntaxCheck(dataInputStream, totalLength);
                           break;
                        case 5: processStoreTestProgram(dataInputStream, totalLength);
                           break;
                        /*case 6: processLogFile(dataInputStream, totalLength);
                           break;
                        case 7: processLogFile(dataInputStream, totalLength);
                           break;*/
                        default: 
                           //for(int i=0; i<=totalLength; i++) {
                           clearStream(dataInputStream);
                           //}
                           System.out.println("No such an option");
                     } // end switch*/
                  
                  } // end if
                  else {
                     JOptionPane.showMessageDialog(new JFrame(),
                        "The file sent from server contained no data!",
                        "Warning",
                        JOptionPane.WARNING_MESSAGE);	
                  
                  }
               
               	// if you want to solve the problem 1 you will have to uncomment the next command
                  //clientGui.setMenuesAvailable();
               
               } // end while
            
            }
            
               catch(ArrayIndexOutOfBoundsException e) {
                  System.out.println("your index does not suffice");
                  try {
                     clearStream(dataInputStream);
                  }
                     catch(IOException ex) {
                     }
                  System.out.println("array out of bounds exception");
               }
            
            	// TODO: have to inform the main class that there is no connection!
               catch (EOFException e) {
                  JOptionPane.showMessageDialog(new JFrame(),
                     "Connection broken ",
                     "Connection Error",
                     JOptionPane.ERROR_MESSAGE);
                  clientGui.clearConnection();
               
               
               }
               catch (SocketException e) {
                  System.out.println("socket exception occurred"); // must be fixed
               
               }  
               catch (IOException e) {
                  e.printStackTrace();
               
               }   // end try
         
         
         
         } // end public void run
      } // end class ClientThread
   
   } /*end class Client*/
// status: runs
// example: java Client szbg 2000
